﻿Imports Windows.Storage
Imports Windows.UI

Public Class Colorsettings : Inherits BaseModel
    Dim applicationData As ApplicationData
    Private localSettings As ApplicationDataContainer

    Public Event UpdateColorSettings()

    Public Sub New()
        applicationData = Windows.Storage.ApplicationData.Current
        localSettings = applicationData.LocalSettings


        If localSettings.Values("ColorValuesSet") Then
            TeamAColor = LoadColorSettings("TeamAColor")
            TeamBColor = LoadColorSettings("TeamBColor")
            Timecolor = LoadColorSettings("Timecolor")
            Stringcolor = LoadColorSettings("Stringcolor")
            Overtimecolor = LoadColorSettings("Overtimecolor")
        Else
            TeamAColor = Color.FromArgb(255, 255, 255, 255)
            TeamBColor = Color.FromArgb(255, 255, 255, 255)
            Timecolor = Color.FromArgb(255, 20, 255, 50)
            Overtimecolor = Color.FromArgb(255, 255, 50, 20)
        End If

    End Sub

    Private Sub SaveColors()
        SaveColorSettings("TeamAColor", TeamAColor)
        SaveColorSettings("TeamBColor", TeamBColor)
        SaveColorSettings("Timecolor", Timecolor)
        SaveColorSettings("Overtimecolor", Overtimecolor)
        SaveColorSettings("Stringcolor", Stringcolor)
        localSettings.Values("ColorValuesSet") = True
    End Sub

    Private Function LoadColorSettings(Propertyname As String) As Color
        Dim a As Byte = localSettings.Values(Propertyname + "A")
        Dim r As Byte = localSettings.Values(Propertyname + "R")
        Dim g As Byte = localSettings.Values(Propertyname + "G")
        Dim b As Byte = localSettings.Values(Propertyname + "B")
        Return Color.FromArgb(a, r, g, b)
    End Function
    Private Sub SaveColorSettings(Propertyname As String, c As Color)
        localSettings.Values(Propertyname + "A") = c.A
        localSettings.Values(Propertyname + "R") = c.R
        localSettings.Values(Propertyname + "G") = c.G
        localSettings.Values(Propertyname + "B") = c.B
        RaiseEvent UpdateColorSettings()
    End Sub


    Public Property SaveColor As New RelayCommand(Sub()
                                                      SaveColors()
                                                  End Sub, True)
    Public Property SameColorLikeTeamA As New RelayCommand(Sub()
                                                               TeamBColor = TeamAColor
                                                               SaveColors()
                                                           End Sub, True)
    Public Property SameColorLikeTime As New RelayCommand(Sub()
                                                              Overtimecolor = Timecolor
                                                              SaveColors()
                                                          End Sub, True)
    Private _TeamAColor As Color
    Public Property TeamAColor() As Color
        Get
            Return _TeamAColor
        End Get
        Set(ByVal value As Color)
            _TeamAColor = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _TeamBColor As Color
    Public Property TeamBColor() As Color
        Get
            Return _TeamBColor
        End Get
        Set(ByVal value As Color)
            _TeamBColor = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _Timecolor As Color
    Public Property Timecolor() As Color
        Get
            Return _Timecolor
        End Get
        Set(ByVal value As Color)
            _Timecolor = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _Overtimecolor As Color
    Public Property Overtimecolor() As Color
        Get
            Return _Overtimecolor
        End Get
        Set(ByVal value As Color)
            _Overtimecolor = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _Stringcolor As Color
    Public Property Stringcolor() As Color
        Get
            Return _Stringcolor
        End Get
        Set(ByVal value As Color)
            _Stringcolor = value
            NotifyPropertyChanged()
        End Set
    End Property
End Class
