﻿Imports System.Text
Imports System.Text.RegularExpressions
Imports Windows.Storage
Imports Windows.Storage.Streams
Imports Windows.UI

Public Class Font : Inherits BaseModel

    Private _FontName As String
    Public Property Fontname() As String
        Get
            Return _FontName
        End Get
        Set(ByVal value As String)
            _FontName = value
            NotifyPropertyChanged()
        End Set
    End Property
    Private charvalues As New Dictionary(Of Integer, Color(,))

    Dim version As Int16
    Dim imagewidth As Integer
    Dim imageheight As Integer
    Dim cellwidth As Integer
    Dim cellheight As Integer
    Dim bpp As Byte
    Dim offset As Byte
    Dim charWidths() As Byte

    Public Sub New(Sourcefile As StorageFile)
        Fontname = Sourcefile.DisplayName
        Using sr = New FileStream(Sourcefile.Path, FileMode.Open), br As New BinaryReader(sr)

            version = br.ReadInt16
            imagewidth = br.ReadInt32
            imageheight = br.ReadInt32
            cellwidth = br.ReadInt32
            cellheight = br.ReadInt32
            bpp = br.ReadByte
            offset = br.ReadByte
            charWidths = br.ReadBytes(256)

            If sr.Position = 276 Then


                'Read char data from bitmap
                Dim columns As Integer = CInt(imagewidth / cellwidth)
                Dim rows As Integer = CInt(imageheight / cellheight)


                Dim temporaryBitmap(imagewidth - 1, imageheight - 1) As Color
                For y As Integer = 0 To imageheight - 1
                    For x As Integer = 0 To imagewidth - 1

                        temporaryBitmap(x, y) = Color.FromArgb(255, br.ReadByte, br.ReadByte, br.ReadByte)
                    Next
                Next

                'Generate char collection
                Dim currentchar = 0
                For row As Integer = 0 To rows - 1
                    For column As Integer = 0 To columns - 1
                        Try
                            Dim newChar(charWidths(currentchar + offset) - 1, cellheight - 1) As Color
                            Dim newx As Integer = 0
                            Dim newy As Integer = 0
                            Try
                                For x As Integer = column * cellwidth To column * cellwidth + charWidths(currentchar + offset) - 1
                                    For y As Integer = row * cellheight To row * cellheight + cellheight - 1
                                        newChar(newx, newy) = temporaryBitmap(x, y)
                                        newy += 1
                                    Next
                                    newy = 0
                                    newx += 1
                                Next
                            Catch
                                Dim abc = 0
                            End Try

                            charvalues.Add(currentchar + offset, newChar)
                            currentchar += 1
                        Catch
                            Dim ddd = 0
                        End Try
                    Next
                Next

            End If

        End Using

    End Sub

    Public Function GetBitmapFromString(source As String, desiredColor As Color) As Pixel(,)
        Dim result As Pixel(,)

        Dim chars() As Byte = Encoding.UTF8.GetBytes(source)
        Dim resultbuffer As New List(Of Color(,))
        Dim totalwidth As Integer = 0
        Dim totalheight As Integer = 0
        For Each item In chars
            Dim charbuffer = charvalues(item)
            totalwidth += charbuffer.GetUpperBound(0)
            If charbuffer.GetUpperBound(1) > totalheight Then
                totalheight = charbuffer.GetUpperBound(1)
            End If
            resultbuffer.Add(charbuffer)
        Next
        Dim currentXOffset As Integer = 0
        ' If totalwidth < 144 AndAlso totalheight < 40 Then
        ReDim result(totalwidth, totalheight)
            For Each item In resultbuffer
                For x As Integer = 0 To item.GetUpperBound(0)
                    For y As Integer = 0 To item.GetUpperBound(1)
                        If item(x, y).R <> 0 AndAlso item(x, y).G <> 0 AndAlso item(x, y).B <> 0 Then
                            result(x + currentXOffset, y) = New Pixel(desiredColor)
                        Else
                            result(x + currentXOffset, y) = New Pixel(Color.FromArgb(255, 0, 0, 0))
                        End If
                    Next
                Next
                currentXOffset += item.GetUpperBound(0)
            Next
            Return result
        'Else
        'Return Nothing
        'End If

    End Function

End Class
