﻿Imports Windows.ApplicationModel.Core
Imports Windows.Storage
Imports Windows.System.Threading
Imports Windows.UI.Core

Public Class Gametimer : Inherits BaseModel

    Private MaximumGametime As TimeSpan
    Private StartGameTime As TimeSpan

    Public GoalsTeamAChanged As Boolean
    Public GoalsTeamBChanged As Boolean

    Public ClearDisplay As Boolean
    '   
    Public Property StartTimer() As New RelayCommand(Sub()
                                                         setgametime()
                                                         StartButtonEnabled = False
                                                         StopButtonEnabled = True
                                                         DispatcherTimerSetup()
                                                         GoalsTeamAChanged = True
                                                         GoalsTeamBChanged = True
                                                         ClearDisplay = True
                                                         RaiseEvent UpdateDisplay()
                                                     End Sub, True)
    Public Property StopTimer() As New RelayCommand(Sub()
                                                        StartButtonEnabled = True
                                                        StopButtonEnabled = False
                                                        dispatcherTimer.Stop()
                                                        GametimerActive = False
                                                        IncHalftime()
                                                        ClearDisplay = True
                                                        GoalsTeamAChanged = True
                                                        GoalsTeamBChanged = True
                                                        CurrentGametime = String.Format("{0:##0}:{1:00}", StartGameTime.TotalMinutes, StartGameTime.Seconds)
                                                        CurrentOvertime = String.Empty
                                                        RaiseEvent UpdateDisplay()
                                                    End Sub, True)

    Public Property GoalTeamAInc() As New RelayCommand(Sub()
                                                           Dim ts As String = (CInt(CurrentGametime.Split(":").First.Replace("+", "")) + 1).ToString
                                                           If CurrentOvertime <> String.Empty Then
                                                               ts += "+"
                                                               ts += (CInt(CurrentOvertime.Split(":").First.Replace("+", "")) + 1).ToString
                                                           End If
                                                           ShottimesTeamA.Add(New Shottimes With {.Timestamp = ts})
                                                           GoalsTeamAChanged = True
                                                           RaiseEvent UpdateDisplay()

                                                       End Sub, True)
    Public Property GoalTeamBInc() As New RelayCommand(Sub()
                                                           Dim ts As String = (CInt(CurrentGametime.Split(":").First.Replace("+", "")) + 1).ToString
                                                           If CurrentOvertime <> String.Empty Then
                                                               ts += "+"
                                                               ts += (CInt(CurrentOvertime.Split(":").First.Replace("+", "")) + 1).ToString
                                                           End If
                                                           ShottimesTeamB.Add(New Shottimes With {.Timestamp = ts})
                                                           GoalsTeamBChanged = True
                                                           RaiseEvent UpdateDisplay()

                                                       End Sub, True)
    Public Property GoalTeamADec() As New RelayCommand(Sub()
                                                           If ShottimesTeamA.Count > 0 Then
                                                               ShottimesTeamA.Remove(ShottimesTeamA.Last)
                                                           End If
                                                           GoalsTeamAChanged = True
                                                           RaiseEvent UpdateDisplay()

                                                       End Sub, True)
    Public Property GoalTeamBDec() As New RelayCommand(Sub()
                                                           If ShottimesTeamB.Count > 0 Then
                                                               ShottimesTeamB.Remove(ShottimesTeamB.Last)
                                                           End If
                                                           GoalsTeamBChanged = True
                                                           RaiseEvent UpdateDisplay()

                                                       End Sub, True)
    Public Property HalftimeInc() As New RelayCommand(Sub()
                                                          IncHalftime()
                                                          RaiseEvent UpdateDisplay()

                                                      End Sub, True)
    Public Property HalftimeDec() As New RelayCommand(Sub()
                                                          DecHalftime()
                                                          RaiseEvent UpdateDisplay()

                                                      End Sub, True)
    Public Property ResetGoals() As New RelayCommand(Sub()
                                                         ShottimesTeamA.Clear()
                                                         ShottimesTeamB.Clear()
                                                         GoalsTeamAChanged = True
                                                         GoalsTeamBChanged = True
                                                         ClearDisplay = True
                                                         RaiseEvent UpdateDisplay()
                                                     End Sub, True)
    Public Property ResetTimer() As New RelayCommand(Sub()
                                                         CurrentGametime = "0:00"
                                                         CurrentOvertime = String.Empty
                                                         Halftime = 1
                                                         setgametime()
                                                         GoalsTeamAChanged = True
                                                         GoalsTeamBChanged = True
                                                         ClearDisplay = True
                                                         RaiseEvent UpdateDisplay()
                                                     End Sub, True)

    Public Property ResetAll() As New RelayCommand(Sub()
                                                       CurrentGametime = "0:00"
                                                       CurrentOvertime = String.Empty
                                                       Halftime = 1
                                                       Overtime = TimeSpan.FromMinutes(0)
                                                       ShottimesTeamA.Clear()
                                                       ShottimesTeamB.Clear()
                                                       GoalsTeamAChanged = True
                                                       GoalsTeamBChanged = True
                                                       ClearDisplay = True
                                                       setgametime()
                                                       RaiseEvent UpdateDisplay()
                                                   End Sub, True)


    Private Sub IncHalftime()
        Halftime += 1
        If Halftime > 5 Then Halftime = 4
        setgametime()
    End Sub
    Private Sub DecHalftime()
        Halftime -= 1
        If Halftime < 1 Then Halftime = 1
        setgametime()
    End Sub
    Private Sub setgametime()
        Select Case Halftime
            Case 1
                StartGameTime = New TimeSpan(0, 0, 0)
                MaximumGametime = New TimeSpan(0, TimePerHalftime, 0)
            Case 2
                StartGameTime = New TimeSpan(0, TimePerHalftime, 0)
                MaximumGametime = New TimeSpan(0, TimePerHalftime * 2, 0)
            Case 3
                StartGameTime = New TimeSpan(0, TimePerHalftime * 2, 0)
                MaximumGametime = New TimeSpan(0, 2 * TimePerHalftime + TimeForAdditionalTime, 0)
            Case 4
                StartGameTime = New TimeSpan(0, 2 * TimePerHalftime + TimeForAdditionalTime, 0)
                MaximumGametime = New TimeSpan(0, 2 * TimePerHalftime + 2 * TimeForAdditionalTime, 0)
            Case Else
                StartGameTime = New TimeSpan(0, 0, 0)
                MaximumGametime = New TimeSpan(0, 0, 0)
        End Select
    End Sub
    Public Sub New()
        GametimerActive = False

        applicationData = Windows.Storage.ApplicationData.Current
        localSettings = applicationData.LocalSettings

        Try
            TimePerHalftime = localSettings.Values("Halftimeduration")
            TimeForAdditionalTime = localSettings.Values("AdditionalTime")
        Catch
            TimePerHalftime = 45
            TimeForAdditionalTime = 15
            localSettings.Values("Halftimeduration") = TimePerHalftime
            localSettings.Values("AdditionalTime") = TimeForAdditionalTime
        End Try

        CurrentOvertime = String.Empty
    End Sub

    Public Property GametimerActive As Boolean

    Public Sub DispatcherTimerSetup()
        dispatcherTimer = New DispatcherTimer
        dispatcherTimer.Interval = New TimeSpan(0, 0, 0, 0, 250)
        AddHandler dispatcherTimer.Tick, AddressOf dispatcherTimer_Tick
        startTime = DateTimeOffset.Now
        lastTime = startTime
        dispatcherTimer.Start()
        GametimerActive = True
    End Sub

    Private Sub dispatcherTimer_Tick(sender As Object, e As EventArgs)
        Dim time As DateTimeOffset = DateTimeOffset.Now
        Dim span As TimeSpan = time.Subtract(startTime)
        lastTime = time
        If span.TotalMilliseconds + StartGameTime.TotalMilliseconds > MaximumGametime.TotalMilliseconds Then
            'Overtime
            stopTime = time
            span = span + StartGameTime - MaximumGametime
            CurrentGametime = String.Format("{0:##0}:{1:00}", MaximumGametime.TotalMilliseconds \ 60000, MaximumGametime.Seconds)
            CurrentOvertime = String.Format("+{0:##0}:{1:00}", (span.TotalMilliseconds \ 60000), span.Seconds)
        Else
            'No Overtime
            CurrentGametime = String.Format("{0:##0}:{1:00}", span.TotalMilliseconds \ 60000 + StartGameTime.TotalMilliseconds \ 60000, span.Seconds)
            CurrentOvertime = String.Empty
        End If
        RaiseEvent UpdateDisplay()
    End Sub

    Public Event UpdateDisplay()

    Private applicationData
    Private localSettings
    Private _overtime As TimeSpan
    Private _StartButtonEnabled As Boolean = True
    Private _StopButtonEnabled As Boolean = False
    Private dispatcherTimer As DispatcherTimer
    Private startTime As DateTimeOffset
    Private lastTime As DateTimeOffset
    Private stopTime As DateTimeOffset
    Private _TimePerHalftime As TimeSpan
    Private _halftime As Integer = 1
    Private _CurrentValue As String = "0:00"
    Private _CurrentOvertime As String
    Private _goalChangeEnabled As Boolean
    Private _TimeForAdditionalTime As Integer


    Property ShottimesTeamA As New ObservableCollection(Of Shottimes)
    Property ShottimesTeamB As New ObservableCollection(Of Shottimes)


    Public Property StopButtonEnabled() As Boolean
        Get
            Return _StopButtonEnabled
        End Get
        Set(ByVal value As Boolean)
            _StopButtonEnabled = value
            NotifyPropertyChanged()
        End Set
    End Property
    Public Property StartButtonEnabled() As Boolean
        Get
            Return _StartButtonEnabled
        End Get
        Set(ByVal value As Boolean)
            _StartButtonEnabled = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property Overtime() As TimeSpan
        Get
            Return _overtime
        End Get
        Set(ByVal value As TimeSpan)
            _overtime = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property Halftime() As Integer
        Get
            Return _halftime
        End Get
        Set(ByVal value As Integer)
            _halftime = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property TimeForAdditionalTime() As Integer
        Get
            Return _TimeForAdditionalTime
        End Get
        Set(ByVal value As Integer)
            _TimeForAdditionalTime = value
            NotifyPropertyChanged()
            localSettings.values("AdditionalTime") = TimeForAdditionalTime
        End Set
    End Property

    Public Property TimePerHalftime As Integer
        Get
            Return _TimePerHalftime.Minutes
        End Get
        Set(value As Integer)
            _TimePerHalftime = New TimeSpan(0, value, 0)
            NotifyPropertyChanged()
            localSettings.Values("Halftimeduration") = TimePerHalftime
        End Set
    End Property

    Public Property CurrentOvertime As String
        Get
            Return _CurrentOvertime
        End Get
        Set(value As String)
            _CurrentOvertime = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property CurrentGametime() As String
        Get
            Return _CurrentValue
        End Get
        Set(ByVal value As String)
            _CurrentValue = value
            NotifyPropertyChanged()
        End Set
    End Property


End Class
