﻿
Imports System.Xml.Serialization
Imports Videowall
Imports Windows.Storage

Public Class Team : Inherits BaseModel



    Private _Teamname As String = "empty"
    Public Property Teamname() As String
        Get
            Return _Teamname
        End Get
        Set(ByVal value As String)
            _Teamname = value
            NotifyPropertyChanged()
        End Set
    End Property

    Public Property PlayerList As New ObservableCollection(Of Playerdata)

    <XmlIgnore>
    Public Property AddPlayer() As New RelayCommand(Sub()
                                                        Dim pd As New Playerdata
                                                        AddHandler pd.DisplayPlayer, AddressOf HandleDisplayPlayerEvent
                                                        AddHandler pd.RemovePlayer, AddressOf HandleRemovePlayer
                                                        PlayerList.Add(New Playerdata)
                                                        RemovePlayerEnabled = True
                                                        ClearPlayerListEnabled = True
                                                    End Sub, True)

    Private Sub HandleRemovePlayer(Player As Playerdata)
        PlayerList.Remove(Player)
    End Sub

    Public Event DisplayPlayer(Player As Playerdata)

    Private Sub HandleDisplayPlayerEvent(Player As Playerdata)
        RaiseEvent DisplayPlayer(Player)
    End Sub


    <XmlIgnore>
    Public Property ClearList() As New RelayCommand(Async Sub()

                                                        Dim locationPromptDialog As ContentDialog = New ContentDialog With {.Title = "Frage",
.Content = "Spielerliste löschen?",
.CloseButtonText = "Abbruch",
.PrimaryButtonText = "Ok"
    }
                                                        Dim result As ContentDialogResult = Await locationPromptDialog.ShowAsync()
                                                        If result = ContentDialogResult.Primary Then
                                                            PlayerList.Clear()
                                                            RemovePlayerEnabled = False
                                                            ClearPlayerListEnabled = False
                                                        End If
                                                    End Sub, True)

    <XmlIgnore>
    Public Property SavePlayerlist As New RelayCommand(Async Sub()
                                                           Dim savePicker = New Windows.Storage.Pickers.FileSavePicker()
                                                           savePicker.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.DocumentsLibrary
                                                           'Dropdown of file types the user can save the file as
                                                           savePicker.FileTypeChoices.Add("Plain Text", New List(Of String)({".txt"}))
                                                           'Default file name if the user does Not type one in Or select a file to replace
                                                           savePicker.SuggestedFileName = Teamname + "_Spielerliste"
                                                           Dim file As StorageFile = Await savePicker.PickSaveFileAsync
                                                           If file IsNot Nothing Then
                                                               Using sw As StreamWriter = New StreamWriter(Await file.OpenStreamForWriteAsync)
                                                                   Dim s As XmlSerializer = New XmlSerializer(GetType(Team))
                                                                   s.Serialize(sw, Me)
                                                               End Using
                                                           End If
                                                       End Sub, True)

    <XmlIgnore>
    Public Property LoadPlayerlist As New RelayCommand(Async Sub()
                                                           Dim picker = New Windows.Storage.Pickers.FileOpenPicker()
                                                           picker.ViewMode = Windows.Storage.Pickers.PickerViewMode.Thumbnail
                                                           picker.SuggestedStartLocation = Windows.Storage.Pickers.PickerLocationId.DocumentsLibrary
                                                           picker.FileTypeFilter.Add(".txt")

                                                           Dim File As StorageFile = Await picker.PickSingleFileAsync()
                                                           If File IsNot Nothing Then
                                                               Using sr As StreamReader = New StreamReader(Await File.OpenStreamForReadAsync)
                                                                   Dim s As XmlSerializer = New XmlSerializer(GetType(Team))
                                                                   RaiseEvent TeamLoaded(s.Deserialize(sr))
                                                               End Using
                                                           End If

                                                       End Sub, True)
    Public Event TeamLoaded(Teamdata As Team)

    Private _currentSelectedPlayer As Playerdata
    Public Property CurrentSelectedPlayer() As Playerdata
        Get
            Return _currentSelectedPlayer
        End Get
        Set(ByVal value As Playerdata)
            _currentSelectedPlayer = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _AddPlayerEnabled As Boolean = True
    Public Property AddPlayerEnabled() As Boolean
        Get
            Return _AddPlayerEnabled
        End Get
        Set(ByVal value As Boolean)
            _AddPlayerEnabled = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _RemovePlayerEnabled As Boolean
    Public Property RemovePlayerEnabled() As Boolean
        Get
            Return _RemovePlayerEnabled
        End Get
        Set(ByVal value As Boolean)
            _RemovePlayerEnabled = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private _ClearPlayerListEnabled As Boolean
    Public Property ClearPlayerListEnabled() As Boolean
        Get
            Return _ClearPlayerListEnabled
        End Get
        Set(ByVal value As Boolean)
            _ClearPlayerListEnabled = value
            NotifyPropertyChanged()
        End Set
    End Property
End Class

