﻿Imports Windows.Graphics.Imaging
Imports Windows.Media.Editing
Imports Windows.Storage
Imports Windows.Storage.Streams

Public Class VideoData : Inherits BaseModel

    Private Sourcefile As StorageFile

    Public Event ShowMe(video As VideoData)

    Public Sub New(source As StorageFile)
        Sourcefile = source
        beginInit()
    End Sub

    Private Sub beginInit()
        init().Wait()
    End Sub


    Public Property cmdShowMe() As New RelayCommand(Sub()
                                                        RaiseEvent ShowMe(Me)
                                                    End Sub, True)

    Private Async Function init() As Task
        'Videodata = Await CreateBytestreams.GetVideoBytestream(Sourcefile, 1, 144, 40)


        'https://stackoverflow.com/questions/37301248/how-to-read-frames-from-a-video-as-bitmaps-in-uwp


        Dim mediaClip = Await Windows.Media.Editing.MediaClip.CreateFromFileAsync(Sourcefile)
        Dim mediaComposition = New MediaComposition()
        mediaComposition.Clips.Add(mediaClip)
        Dim ts As TimeSpan = TimeSpan.FromMilliseconds(0)
        Videodata = New List(Of Pixel(,))
        While ts < mediaClip.OriginalDuration
            Dim thumbnail = Await mediaComposition.GetThumbnailAsync(ts, 144, 40, VideoFramePrecision.NearestKeyFrame)
            thumbnail.Seek(0)
            '   Dim bImage As BitmapImage = New BitmapImage()


            Dim decoder As BitmapDecoder = Await BitmapDecoder.CreateAsync(thumbnail) '(bImage)
            Dim transform As New BitmapTransform With {.ScaledHeight = 40, .ScaledWidth = 144}
            Dim pixeldata As PixelDataProvider = Await decoder.GetPixelDataAsync(BitmapPixelFormat.Bgra8,
                                                                                             BitmapAlphaMode.Straight,
                                                                                             transform,
                                                                                             ExifOrientationMode.IgnoreExifOrientation,
                                                                                             ColorManagementMode.DoNotColorManage)

            Dim rawpixel = pixeldata.DetachPixelData
            'Dim width = decoder.PixelWidth
            'Dim height = decoder.PixelHeight

            If rawpixel.Length = 144 * 40 * 4 Then
                Dim Picturedata(144 - 1, 40 - 1) As Pixel
                Dim index As Integer = 0
                For y As Integer = 0 To 39
                    For x As Integer = 0 To 143
                        Try
                            Picturedata(x, y) = New Pixel(rawpixel(index + 2), rawpixel(index + 1), rawpixel(index))
                            Picturedata(x, y).SetBrightness(rawpixel(index + 3))
                            index += 4
                        Catch ex As Exception
                            Debug.WriteLine("SOMETHING WENT WRONG CREATING A VIDEO FRAME")
                        End Try
                    Next
                Next
                Videodata.Add(Picturedata)
            End If






            ts += TimeSpan.FromMilliseconds(100)
        End While


        Name = Sourcefile.DisplayName

    End Function

    Private _thumbnail As BitmapImage
    Public Property Thumbnail() As BitmapImage
        Get
            Return _thumbnail
        End Get
        Set(ByVal value As BitmapImage)
            _thumbnail = value
            NotifyPropertyChanged()
        End Set
    End Property

    Property Videodata As List(Of Pixel(,))
    '   Property Thumbnail As Image
    Private _name As String
    Public Property Name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
            NotifyPropertyChanged()
        End Set
    End Property

End Class
