﻿Imports System.Reflection
Imports System.Text
Imports Newtonsoft.Json
Imports Videowall
Imports Videowall.MainModelBase
Imports Windows.ApplicationModel.Core
Imports Windows.Storage
Imports Windows.System.Profile
Imports Windows.UI
Imports Windows.UI.Core

Public Class MainModel : Inherits MainModelBase(Of MainModel)


    Public Property cmdMainPageLoaded As New RelayCommand(Sub() MainPageLoaded(), True)




#Region "HamburgerMenu"

    Public ReadOnly Property hamburgerMenuControlItemSource
        Get
            Return MenuItem.GetMainItems
        End Get

    End Property
    Public ReadOnly Property HamburgerOptionsItemsSource
        Get
            Return MenuItem.GetOptionsItems
        End Get
    End Property

    Private _SelectedHamburgerOptionItem As MenuItem
    Public Property SelectedHamburgerOptionItem() As MenuItem
        Get
            Return _SelectedHamburgerOptionItem
        End Get
        Set(ByVal value As MenuItem)
            _SelectedHamburgerOptionItem = value
            NotifyPropertyChanged()
            If Not value Is Nothing Then
                Select Case value.Name
                    Case "Einstellungen"
                        CurrentPage = New Options '= New Options
                End Select
            End If
        End Set
    End Property

    Private _SelectedHamburgerMenuItem As MenuItem
    Public Property SelectedHamburgerMenuItem As MenuItem
        Get
            Return _SelectedHamburgerMenuItem
        End Get
        Set(ByVal value As MenuItem)
            _SelectedHamburgerMenuItem = value
            NotifyPropertyChanged()
            If Not value Is Nothing Then
                Select Case value.Name
                    Case "Main"
                        CurrentPage = New Main
                    Case "Teams"
                        CurrentPage = New Teamdisplay
                    Case "Fonts"
                        CurrentPage = New Fonts
                    Case "Pictures"
                        CurrentPage = New Pictures
                    Case "Videos"
                        CurrentPage = New Videos

                End Select
            End If
        End Set
    End Property

    Private _currentPage As Page = New Main
    Public Property CurrentPage As Page
        Get
            Return _currentPage
        End Get
        Set(ByVal value As Page)
            _currentPage = value
            NotifyPropertyChanged()
        End Set
    End Property
#End Region

    Private localSettings As ApplicationDataContainer

#Region "Main Page Loaded"
    Private Sub MainPageLoaded()

        Displayconnection = New Displayconnection
        AddHandler Devicehandler.AddFont, AddressOf AddFontHandler
        AddHandler Devicehandler.AddImage, AddressOf AddImageHandler
        AddHandler Devicehandler.AddVideo, AddressOf AddVideoHandler
        AddHandler Devicehandler.ResetCollections, AddressOf ResetColletionsHandler
        AddHandler Devicehandler.DeviceEnumerationDone, AddressOf Handle_DeviceEnumerationDone
        AddHandler Gametimer.UpdateDisplay, AddressOf UpdateDisplay
        AddHandler Displayconnection.DisplayTestDone, AddressOf Handle_DisplayTestDone
        AddHandler Colorsettings.UpdateColorSettings, AddressOf Handle_UpdateColorSettings
        Devicehandler.WatchDevices()


        'Load team settings
        Dim applicationData = Windows.Storage.ApplicationData.Current
        localSettings = applicationData.LocalSettings


        Try
            PictureVisibleTime = localSettings.Values("PictureVisibleTime")
        Catch
            PictureVisibleTime = 5
            localSettings.Values("PictureVisibleTime") = PictureVisibleTime
        End Try


        TeamA = New Team
        TeamB = New Team

        AddHandler TeamA.DisplayPlayer, AddressOf HandleShowString
        AddHandler TeamB.DisplayPlayer, AddressOf HandleShowString
        AddHandler TeamA.TeamLoaded, AddressOf TeamADataLoaded
        AddHandler TeamB.TeamLoaded, AddressOf TeamBDataLoaded

    End Sub

    Private Sub TeamADataLoaded(Teamdata As Team)
        TeamA = Teamdata
    End Sub

    Private Sub TeamBDataLoaded(Teamdata As Team)
        TeamB = Teamdata
    End Sub

    Private Sub Handle_DisplayTestDone()
        Gametimer.ClearDisplay = True
        Gametimer.GoalsTeamAChanged = True
        Gametimer.GoalsTeamBChanged = True
        UpdateDisplay()
    End Sub

    Private _PictureVisibleTime As Integer
    Public Property PictureVisibleTime() As Integer
        Get
            Return _PictureVisibleTime
        End Get
        Set(ByVal value As Integer)
            _PictureVisibleTime = value
            localSettings.Values("PictureVisibleTime") = value
            NotifyPropertyChanged()
        End Set
    End Property

    Private Sub Handle_DeviceEnumerationDone()
        Displayconnection.ActivateBrightness()
        Gametimer.ClearDisplay = True
        Gametimer.GoalsTeamAChanged = True
        Gametimer.GoalsTeamBChanged = True
        For i = 0 To Fonts.Count - 1
            If Fonts(i).Fontname.Contains("20") Then FontIndexForTimer = i
            If Fonts(i).Fontname.Contains("40") Then FontIndexForGoal = i
            If Fonts(i).Fontname.Contains("30") Then FontIndexForName = i
        Next
        If FontIndexForGoal = -1 Or FontIndexForTimer = -1 Then
            Debug.WriteLine("No Font found")
            For x As Integer = 0 To Displayconnection.buffer.GetUpperBound(0)
                For y As Integer = 0 To Displayconnection.buffer.GetUpperBound(1)
                    Displayconnection.buffer(x, y).SetColor(Color.FromArgb(255, 5, 0, 0))
                Next
            Next
            Exit Sub
        End If
        UpdateDisplay()
    End Sub

    Private FontIndexForTimer As Integer = -1
    Private FontIndexForGoal As Integer = -1
    Private FontIndexForName As Integer = -1

    Private Sub ClearDisplay()
        For x As Integer = 0 To Displayconnection.buffer.GetUpperBound(0)
            For y As Integer = 0 To Displayconnection.buffer.GetUpperBound(1)
                Displayconnection.buffer(x, y).SetColor(Color.FromArgb(255, 0, 0, 0))
            Next
        Next
    End Sub

    Private Sub Handle_UpdateColorSettings()
        Gametimer.GoalsTeamAChanged = True
        Gametimer.GoalsTeamBChanged = True
        If Not Gametimer.GametimerActive Then
            UpdateDisplay()
        End If
    End Sub

    Private Sub UpdateDisplay()
        If ShowOtherData Then Exit Sub
        'TODO: make Update
        If Fonts.Count > 0 Then

            Try

                If Gametimer.ClearDisplay Then
                    ClearDisplay()
                    Gametimer.ClearDisplay = False
                End If
            Catch ex As Exception
                Dim ddd = 0
            End Try
            Try

                If Gametimer.GoalsTeamAChanged Then
                    Dim GoalsA = Fonts(FontIndexForGoal).GetBitmapFromString(Gametimer.ShottimesTeamA.Count.ToString, Colorsettings.TeamAColor) 'Color.FromArgb(255, 255, 255, 255))
                    If GoalsA IsNot Nothing Then
                        For x As Integer = 0 To GoalsA.GetUpperBound(0)
                            For y As Integer = 0 To GoalsA.GetUpperBound(1)
                                If x >= 0 And x < 144 And y >= 0 And y < 40 Then
                                    Displayconnection.buffer(x, y).SetColor(GoalsA(x, y).GetColor)
                                End If
                            Next
                        Next
                    End If
                    Gametimer.GoalsTeamAChanged = False
                End If
            Catch ex As Exception
                Dim ddd = 0
            End Try
            Try

                If Gametimer.GoalsTeamBChanged Then
                    Dim GoalsB = Fonts(FontIndexForGoal).GetBitmapFromString(Gametimer.ShottimesTeamB.Count.ToString, Colorsettings.TeamBColor) ' Color.FromArgb(255, 255, 255, 255))
                    If GoalsB IsNot Nothing Then
                        Dim xOffset As Integer = Displayconnection.buffer.GetUpperBound(0) - GoalsB.GetUpperBound(0) - 1
                        For x As Integer = 0 To GoalsB.GetUpperBound(0)
                            For y As Integer = 0 To GoalsB.GetUpperBound(1)
                                If x + xOffset >= 0 And x + xOffset < 144 And y >= 0 And y < 40 Then
                                    Displayconnection.buffer(xOffset + x, y).SetColor(GoalsB(x, y).GetColor)
                                End If
                            Next
                        Next
                    End If
                    Gametimer.GoalsTeamBChanged = False
                End If
            Catch ex As Exception
                Dim ddd = 0
            End Try
            Try

                Dim Currenttime = Fonts(FontIndexForTimer).GetBitmapFromString(Gametimer.CurrentGametime.ToString, Colorsettings.Timecolor) 'Color.FromArgb(255, 255, 255, 0))
                If Currenttime IsNot Nothing Then
                    Dim xOffset As Integer = (144 / 2) - (Currenttime.GetUpperBound(0) / 2) - 1
                    For x As Integer = 0 To Currenttime.GetUpperBound(0)
                        For y As Integer = 0 To Currenttime.GetUpperBound(1)
                            If x + xOffset >= 0 And x + xOffset < 144 And y >= 0 And y < 40 Then
                                Displayconnection.buffer(xOffset + x, y).SetColor(Currenttime(x, y).GetColor)
                            End If
                        Next
                    Next
                End If

            Catch ex As Exception
                Dim ddd = 0
            End Try
            Try
                If Gametimer.CurrentOvertime <> String.Empty Then
                    Dim overtime = Fonts(FontIndexForTimer).GetBitmapFromString(Gametimer.CurrentOvertime.ToString, Colorsettings.Overtimecolor) ' Color.FromArgb(255, 255, 0, 0))
                    If overtime IsNot Nothing Then
                        Dim xOffset As Integer = (144 / 2) - (overtime.GetUpperBound(0) / 2) - 1
                        'TODO: Cahnge font format
                        Dim yOffset As Integer = 20 ' Currenttime.GetUpperBound(1) + 3
                        For x As Integer = 0 To overtime.GetUpperBound(0)
                            For y As Integer = 0 To overtime.GetUpperBound(1) 'overtime.GetUpperBound(1)
                                If x + xOffset >= 0 And x + xOffset < 144 And y + yOffset >= 0 And y + yOffset < 40 Then
                                    Displayconnection.buffer(xOffset + x, y + yOffset).SetColor(overtime(x, y).GetColor)
                                End If
                            Next
                        Next
                    End If
                End If

            Catch ex As Exception
                Dim ddd = 0
            End Try
        End If
    End Sub

    Private Async Sub ResetColletionsHandler()
        Await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(
         CoreDispatcherPriority.Normal, Sub()
                                            Videos.Clear()
                                            Fonts.Clear()
                                            Images.Clear()
                                        End Sub)
    End Sub

    Private Async Sub AddVideoHandler(video As VideoData)
        Await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(
         CoreDispatcherPriority.Normal, Sub()
                                            AddHandler video.ShowMe, AddressOf HandleShowVideo
                                            Videos.Add(video)
                                        End Sub)
    End Sub
    Private Async Sub AddImageHandler(image As ImageData)
        Await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(
         CoreDispatcherPriority.Normal, Sub()
                                            AddHandler image.ShowMe, AddressOf HandleShowPicture
                                            Images.Add(image)
                                        End Sub)
    End Sub

    Private ShowOtherData As Boolean

    Private Async Sub HandleShowPicture(Image As ImageData)
        ShowOtherData = True
        ClearDisplay()
        Await Task.Delay(100)
        Dim xOffset As Integer = 144 / 2 - Image.Imagedata.GetUpperBound(0) / 2
        Dim yOffset As Integer = 40 / 2 - Image.Imagedata.GetUpperBound(1) / 2
        Dim xmax As Integer = Image.Imagedata.GetUpperBound(0)
        Dim ymax As Integer = Image.Imagedata.GetUpperBound(1)
        For y As Integer = 0 To ymax
            For x As Integer = 0 To xmax
                If x + xOffset >= 0 AndAlso y + yOffset >= 0 AndAlso x + xOffset <= Displayconnection.buffer.GetUpperBound(0) AndAlso y + yOffset <= Displayconnection.buffer.GetUpperBound(1) Then

                    Displayconnection.buffer(x + xOffset, y + yOffset) = New Pixel(Image.Imagedata(x, y).GetColor)
                    Displayconnection.buffer(x + xOffset, y + yOffset).SetBrightness(Displayconnection.CurrentBrightness)
                End If
            Next
        Next
        Await Task.Delay(PictureVisibleTime * 1000)
        ClearDisplay()
        ShowOtherData = False
        Gametimer.ClearDisplay = True
        Gametimer.GoalsTeamAChanged = True
        Gametimer.GoalsTeamBChanged = True
        UpdateDisplay()
    End Sub
    Private Async Sub HandleShowVideo(video As VideoData)
        ShowOtherData = True
        ClearDisplay()
        Dim itemsCount = video.Videodata.Count
        For i As Integer = 0 To video.Videodata.Count - 1
            Dim xmax As Integer = video.Videodata(i).GetUpperBound(0)
            Dim ymax As Integer = video.Videodata(i).GetUpperBound(1)
            Dim currentFrame = video.Videodata(i)
            For y As Integer = 0 To ymax
                For x As Integer = 0 To xmax
                    If x >= 0 AndAlso y >= 0 AndAlso x <= Displayconnection.buffer.GetUpperBound(0) AndAlso y <= Displayconnection.buffer.GetUpperBound(1) Then
                        If Not currentFrame(x, y) Is Nothing Then
                            Displayconnection.buffer(x, y) = New Pixel(currentFrame(x, y).GetColor)
                            Displayconnection.buffer(x, y).SetBrightness(Displayconnection.CurrentBrightness)
                        End If
                    End If
                Next
            Next
            Await Task.Delay(100)
        Next
        Await Task.Delay(PictureVisibleTime * 1000)
        ClearDisplay()

        ShowOtherData = False
        Gametimer.ClearDisplay = True
        Gametimer.GoalsTeamAChanged = True
        Gametimer.GoalsTeamBChanged = True
        UpdateDisplay()
    End Sub


    Private Async Sub HandleShowString(player As Playerdata)
        Dim Playerbuffer = Fonts(FontIndexForName).GetBitmapFromString(player.Name, Colorsettings.Stringcolor)
        If Playerbuffer Is Nothing Then Exit Sub
        ShowOtherData = True
        Dim yoffset = Displayconnection.buffer.GetUpperBound(1) / 2 - Playerbuffer.GetUpperBound(1) / 2
        Dim xoffset = 0
        Dim maxXOffset As Integer = 0
        Dim xMove As Integer = 0
        If Playerbuffer.GetUpperBound(0) > Displayconnection.buffer.GetUpperBound(0) Then
            maxXOffset = Playerbuffer.GetUpperBound(0) - Displayconnection.buffer.GetUpperBound(0)
        End If
        Dim xmax As Integer = Displayconnection.buffer.GetUpperBound(0)
        Dim ymax As Integer = Playerbuffer.GetUpperBound(1) / 2
        Do
            ClearDisplay()
            For y As Integer = 0 To ymax
                For x As Integer = 0 To xmax
                    Displayconnection.buffer(x, y + yoffset) = New Pixel((Playerbuffer(x + 1, y).GetColor))
                    Displayconnection.buffer(x, y + yoffset).SetBrightness(Displayconnection.CurrentBrightness)
                Next
            Next
            If Not xMove > maxXOffset Then
                Await Task.Delay(50)
            End If
            xMove += 1
        Loop Until xMove > maxXOffset
        Await Task.Delay(1000)
        ShowOtherData = False
    End Sub

    Private Async Sub AddFontHandler(font As Font)

        Await CoreApplication.MainView.CoreWindow.Dispatcher.RunAsync(
         CoreDispatcherPriority.Normal, Sub() Fonts.Add(font))
    End Sub
#End Region

#Region "Properties"
    Public Property Displayconnection As Displayconnection
    Public Property Devicehandler As New Devicehandler
    Public Property Gametimer As New Gametimer
    Public Property Colorsettings As New Colorsettings
    Public Property Fonts As New ObservableCollection(Of Font)
    Public Property Images As New ObservableCollection(Of ImageData)
    Public Property Videos As New ObservableCollection(Of VideoData)



    Public Property SaveTeamSettings() As New RelayCommand(Sub()

                                                               '   localSettings.Values("TeamASettings") = JsonConvert.SerializeObject(TeamA)
                                                               '  localSettings.Values("TeamBSettings") = JsonConvert.SerializeObject(TeamB)
                                                               'Try
                                                               Dim applicationData = Windows.Storage.ApplicationData.Current
                                                               Dim localSettings = applicationData.LocalSettings

                                                               Dim test = JsonConvert.SerializeObject(TeamA)
                                                               localSettings.Values("TeamAPlayerlist") = test

                                                               test = JsonConvert.SerializeObject(TeamB)
                                                               localSettings.Values("TeamBPlayerlist") = test
                                                               ' Catch
                                                               'End Try

                                                           End Sub, True)


    Private _TeamA As New Team
    Public Property TeamA() As Team
        Get
            Return _TeamA
        End Get
        Set(ByVal value As Team)
            If value IsNot Nothing Then
                _TeamA = value
                NotifyPropertyChanged()
            End If
        End Set
    End Property

    Private _TeamB As New Team
    Public Property TeamB() As Team
        Get
            Return _TeamB
        End Get
        Set(ByVal value As Team)
            If value IsNot Nothing Then
                _TeamB = value
                NotifyPropertyChanged()
            End If
        End Set
    End Property
    'Private _CurrentSelectedImage As ImageData
    'Public Property CurrentSelectedImage() As ImageData
    '    Get
    '        Return _CurrentSelectedImage
    '    End Get
    '    Set(ByVal value As ImageData)
    '        _CurrentSelectedImage = value
    '        NotifyPropertyChanged()
    '    End Set
    'End Property

    'Private _CurrentSelectedVideo As VideoData
    'Public Property CurrentSelectedVideo() As VideoData
    '    Get
    '        Return _CurrentSelectedVideo
    '    End Get
    '    Set(ByVal value As VideoData)
    '        _CurrentSelectedVideo = value
    '    End Set
    'End Property

    Private _Version As String
    Public ReadOnly Property Version() As String
        Get
            Dim info = Package.Current.Id.Version
            Return String.Format("{0}.{1}.{2}.{3}", info.Major, info.Minor, info.Build, info.Revision)
        End Get
    End Property

#End Region
End Class
